﻿<UserControl x:Class="CMS.Views.InvoiceView"
        xmlns="http://schemas.microsoft.com/winfx/2006/xaml/presentation"
        xmlns:x="http://schemas.microsoft.com/winfx/2006/xaml"
        xmlns:dx="http://schemas.devexpress.com/winfx/2008/xaml/core"
             xmlns:dxg="http://schemas.devexpress.com/winfx/2008/xaml/grid"
             xmlns:dxb="http://schemas.devexpress.com/winfx/2008/xaml/bars"
             xmlns:dxr="http://schemas.devexpress.com/winfx/2008/xaml/ribbon"
             xmlns:dxlc="http://schemas.devexpress.com/winfx/2008/xaml/layoutcontrol"
             xmlns:dxmvvm="http://schemas.devexpress.com/winfx/2008/xaml/mvvm"
             xmlns:viewModel="clr-namespace:CMS.ViewModels"
             xmlns:d="http://schemas.microsoft.com/expression/blend/2008"
        xmlns:mc="http://schemas.openxmlformats.org/markup-compatibility/2006" xmlns:dxe="http://schemas.devexpress.com/winfx/2008/xaml/editors"
             mc:Ignorable="d" d:DesignHeight="400" d:DesignWidth="600" DataContext="{dxmvvm:ViewModelSource viewModel:InvoiceViewModel}">
    <UserControl.Resources>
        <ResourceDictionary Source="../../Resources/EntityViewResources.xaml" />
    </UserControl.Resources>
    <DockPanel Style="{StaticResource EntityView.RootContainer}">
        <dxr:RibbonControl DockPanel.Dock="Top" Style="{StaticResource EntityView.RibbonControl}" ShowApplicationButton="False" ToolbarShowMode="Hide">
            <dxr:RibbonDefaultPageCategory>
                <dxr:RibbonPage Style="{StaticResource EntityView.RibbonPage}">
                    <dxr:RibbonPageGroup Style="{StaticResource EntityView.RibbonPageGroup.Main}">
                        <dxb:BarButtonItem Style="{StaticResource EntityView.Command.Save}" />
                        <dxb:BarButtonItem Style="{StaticResource EntityView.Command.SaveAndClose}" />
                        <dxb:BarButtonItem Style="{StaticResource EntityView.Command.SaveAndNew}" />
                        <dxb:BarButtonItem Style="{StaticResource EntityView.Command.Reset}" />
                        <dxb:BarButtonItem Style="{StaticResource EntityView.Command.Delete}" />
                        <dxb:BarButtonItem Style="{StaticResource EntityView.Command.Close}" />
                    </dxr:RibbonPageGroup>
                    <dxr:RibbonPageGroup Style="{StaticResource EntityView.RibbonPageGroup.Layout}">
                        <dxb:BarCheckItem Style="{StaticResource EntityView.Command.Customize}" IsChecked="{Binding IsCustomization, ElementName=layoutControl}" />
                        <dxb:BarButtonItem Style="{StaticResource EntityView.Command.SaveLayout}" />
                        <dxb:BarButtonItem Style="{StaticResource EntityView.Command.ResetLayout}" />
                    </dxr:RibbonPageGroup>
                </dxr:RibbonPage>
            </dxr:RibbonDefaultPageCategory>
        </dxr:RibbonControl>
        <dxr:RibbonStatusBarControl DockPanel.Dock="Bottom" Style="{StaticResource EntityView.RibbonStatusBar}" />
        <dxlc:LayoutControl x:Name="layoutControl" Style="{StaticResource EntityView.LayoutControl}">
            <dxlc:DataLayoutItem x:Name="layoutItemInvoiceNumber" Binding="{Binding Entity.InvoiceNumber, UpdateSourceTrigger=PropertyChanged}" Label="Number" />
            <dxlc:DataLayoutItem x:Name="layoutItemInvoiceStatus" Binding="{Binding Entity.InvoiceStatus, UpdateSourceTrigger=PropertyChanged}" Label="Status" />
            
            <dxlc:DataLayoutItem x:Name="layoutItemSupplier" Binding="{Binding Entity.Supplier, Mode=OneTime}">
                <dxg:LookUpEdit Style="{StaticResource EntityView.SuppliersLookUpEdit}" 
                                DataContext="{Binding ElementName=layoutControl, Path=DataContext}" 
                                EditValue="{Binding Entity.SupplierID, UpdateSourceTrigger=PropertyChanged, ValidatesOnDataErrors=True, NotifyOnSourceUpdated=True}"
                                ItemsSource="{Binding LookUpSuppliers.Entities}" 
                                ValueMember="SupplierID" 
                                DisplayMember="Name"/>
            </dxlc:DataLayoutItem>
            
            <dxlc:DataLayoutItem x:Name="layoutItemTotalPrice" Label="Total Amount">
                <dxe:TextEdit HorizontalContentAlignment="Left" MaskUseAsDisplayFormat="True"
                                   Mask="d0" MaskType="Numeric"
                                   EditValue="{Binding Entity.TotalAmount,Mode=OneWay, UpdateSourceTrigger=PropertyChanged , ValidatesOnDataErrors=True}"
                                   IsReadOnly="True"/>
            </dxlc:DataLayoutItem>
            <dxlc:DataLayoutItem x:Name="layoutItemPaidAmount" Label="Paid Amount">
                <dxe:PopupCalcEdit HorizontalContentAlignment="Left"
                                   EditValueChanged="{DXEvent 'ShowChanges()'}"
                                   Mask="d0" MaskUseAsDisplayFormat="True" 
                                   EditValue="{Binding Entity.PaidAmount, UpdateSourceTrigger=PropertyChanged , ValidatesOnDataErrors=True}"
                                   IsPopupAutoWidth="False" />
            </dxlc:DataLayoutItem>
            <dxlc:DataLayoutItem x:Name="layoutItemRestAmount" Label="Rest Amount">
                <dxe:TextEdit HorizontalContentAlignment="Left"
                                   Mask="d0" MaskType="Numeric" MaskUseAsDisplayFormat="True"
                                   EditValue="{Binding Entity.RestAmount,Mode=OneWay, UpdateSourceTrigger=PropertyChanged , ValidatesOnDataErrors=True}"
                                   IsReadOnly="True"/>
            </dxlc:DataLayoutItem>
            <dxlc:LayoutGroup x:Name="Tabs" View="Tabs" >
                <DockPanel Style="{StaticResource EntityView.Detail.Container}" DataContext="{Binding InvoiceInvoiceItemsDetails}" dxlc:LayoutControl.TabHeader="Invoice Details">
                    <dxb:ToolBarControl DockPanel.Dock="Top" AllowQuickCustomization="False" AllowCustomizationMenu="False">
                        <dxb:BarButtonItem Style="{StaticResource EntityView.Detail.Command.New}" />
                        <dxb:BarButtonItem Style="{StaticResource EntityView.Detail.Command.Edit}" />
                        <dxb:BarButtonItem Style="{StaticResource EntityView.Detail.Command.Delete}" />
                        <dxb:BarButtonItem Style="{StaticResource EntityView.Detail.Command.Refresh}" />
                        <dxb:BarButtonItem Style="{StaticResource EntityView.Detail.Command.Save}" />
                        <dxb:BarButtonItem Style="{StaticResource EntityView.Detail.Command.Reset}" />
                    </dxb:ToolBarControl>
                    <dxg:GridControl x:Name="InvoiceInvoiceItemsDetailsGrid" dx:DXSerializer.SerializationID="InvoiceInvoiceItemsDetailsGrid" Style="{StaticResource EntityView.Detail.GridControl.Editable}">
                        <dxg:GridControl.View>
                            <dxg:TableView Style="{StaticResource EntityView.Detail.TableView}" AutoWidth="True">
                                <dxg:TableView.RowCellMenuCustomizations>
                                    <dxb:BarButtonItem Style="{StaticResource EntityView.Detail.GridCommand.New}" />
                                    <dxb:BarButtonItem Style="{StaticResource EntityView.Detail.GridCommand.Edit}" />
                                    <dxb:BarButtonItem Style="{StaticResource EntityView.Detail.GridCommand.Delete}" />
                                    <dxb:BarButtonItem Style="{StaticResource EntityView.Detail.GridCommand.Refresh}" />
                                </dxg:TableView.RowCellMenuCustomizations>
                            </dxg:TableView>
                        </dxg:GridControl.View>
                        <dxg:GridControl.Columns>
                            <dxg:GridColumn IsSmart="True" FieldName="InvoiceItemID" />
                            <dxg:GridColumn IsSmart="True" FieldName="Quantity" >
                                <dxg:GridColumn.EditSettings>
                                    <dxe:TextEditSettings  Mask="d0" MaskType="Numeric" HorizontalContentAlignment="Center"  MaskUseAsDisplayFormat="True"/>
                                </dxg:GridColumn.EditSettings>
                            </dxg:GridColumn>
                            <dxg:GridColumn IsSmart="True" FieldName="Price" Header="Unit Price">
                                <dxg:GridColumn.EditSettings>
                                    <dxe:TextEditSettings  Mask="d0" MaskType="Numeric" HorizontalContentAlignment="Center"  MaskUseAsDisplayFormat="True"/>
                                </dxg:GridColumn.EditSettings>
                            </dxg:GridColumn>
                            <dxg:GridColumn IsSmart="True" FieldName="Price"  Header="Total Price">
                                <dxg:GridColumn.EditSettings>
                                    <dxe:TextEditSettings  Mask="d0" MaskType="Numeric" HorizontalContentAlignment="Center"  MaskUseAsDisplayFormat="True"/>
                                </dxg:GridColumn.EditSettings>
                            </dxg:GridColumn>
                            <dxg:GridColumn IsSmart="True" FieldName="StockItem.Name" />
                        </dxg:GridControl.Columns>
                        <dxg:GridControl.TotalSummary>
                            <dxg:GridSummaryItem SummaryType="Count" Alignment="Right" />
                        </dxg:GridControl.TotalSummary>
                        <dxg:GridControl.GroupSummary>
                            <dxg:GridSummaryItem SummaryType="Count" />
                        </dxg:GridControl.GroupSummary>
                    </dxg:GridControl>
                </DockPanel>
            </dxlc:LayoutGroup>
        </dxlc:LayoutControl>
    </DockPanel>
</UserControl>